package de.npid7.serverlite.Tasks;

import de.npid7.serverlite.D7ServerLite;
import de.npid7.serverlite.Helpers.Spielzeit;
import net.md_5.bungee.api.ChatColor;
import org.bukkit.Bukkit;
import org.bukkit.Statistic;
import org.bukkit.entity.Player;
import org.bukkit.scheduler.BukkitRunnable;

public class TablistTask {
  long lastTickNano = System.nanoTime();
  long lastSecondNano = lastTickNano;
  int ticksThisSec = 0;
  double tps = 20.0;
  double mspt = 0.0;
  double total_mspt = 0.0;
  long msptlt;

  private void CalcTPS() {
    long now = System.nanoTime();
    double now_mspt = (now - lastTickNano) / 1000000.0;
    lastTickNano = now;
    total_mspt += now_mspt;
    if (now - lastSecondNano >= 1000000000.0) {
      tps = ticksThisSec;
      // Fake Value
      if (tps == 21)
        tps = 20;
      mspt = total_mspt / ticksThisSec;
      total_mspt = 0;
      ticksThisSec = 0;
      lastSecondNano = now;
    }
    ticksThisSec++;
  }

  public TablistTask() {
    run();
  }

  private void displayTablist() {
    for (Player pl : Bukkit.getServer().getOnlinePlayers()) {
      int playtime = Spielzeit.getHours(pl.getStatistic(Statistic.TOTAL_WORLD_TIME));
      String str = " Stunden";
      if (playtime == 1) {
        str = " Stunde";
      }
      pl.setPlayerListHeader(
          "\n§x§5§5§5§5§5§5§lѕ§x§5§B§5§B§5§B§lᴜ§x§6§1§6§1§6§1§lʀ§x§6§7§6§7§6§7§lᴠ§x§6§D§6§D§6§D§lɪ§x§7§3§7§3§7§3§lᴠ§x§7§9§7§9§7§9§lᴀ§x§8§0§8§0§8§0§lʟ§x§8§6§8§6§8§6§lᴘ§x§8§C§8§C§8§C§lʀ§x§9§2§9§2§9§2§lᴏ§x§9§8§9§8§9§8§lᴊ§x§9§E§9§E§9§E§lᴇ§x§A§4§A§4§A§4§lᴋ§x§A§A§A§A§A§A§lᴛ\n"
          + "\n" + ChatColor.GRAY.toString() + "ᴅᴇɪɴ ᴘɪɴɢ" + ChatColor.DARK_GRAY.toString() + ": "
          + ChatColor.GREEN.toString() + pl.getPing() + "   " + ChatColor.GRAY.toString()
          + "ѕᴇʀᴠᴇʀ ᴛᴘѕ" + ChatColor.DARK_GRAY.toString() + ": " + ChatColor.GREEN.toString()
          + String.format("%.1f", tps) + "\n\n" + ChatColor.GRAY.toString() + "ѕᴘɪᴇʟᴢᴇɪᴛ"
          + ChatColor.DARK_GRAY.toString() + ": " + ChatColor.GREEN.toString() + playtime + str
          + "\n");
      pl.setPlayerListFooter("\n");
      String body = "";
      String status = D7ServerLite.getInst().getPlayerConfig().getStatus(pl.getUniqueId());
      if (!status.equals("")) {
        body += "[";
        String color = D7ServerLite.getInst().getPluginConfig().getStatusColor(status);
        if (color == null) {
          color = ChatColor.WHITE.toString();
        }
        body += color;
        body += status;
        body += ChatColor.WHITE.toString();
        body += "] ";
      }
      body += ChatColor.WHITE.toString() + pl.getDisplayName();
      body += " " + ChatColor.RED.toString() + pl.getStatistic(Statistic.DEATHS);
      pl.setPlayerListName(body);
    }
  }

  private void run() {
    new BukkitRunnable() {
      @Override
      public void run() {
        CalcTPS();
        displayTablist();
      }
    }.runTaskTimer(D7ServerLite.getInst(), 0, 0);
  }
}
